import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

JFrame f = new JFrame();  // 1
f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
f.setTitle("JFrame with panel components.");
f.setSize(600, 600);

f.setLayout(new FlowLayout());

JPanel p1 = new JPanel();  // 2
p1.setBackground(Color.gray);
p1.setPreferredSize(new Dimension(100, 100));
f.add(p1);
JPanel p2 = new JPanel();  // 3
p2.setBackground(Color.gray);
p2.setPreferredSize(new Dimension(100, 100));
f.add(p2);
JPanel p3 = new JPanel();  // 4
p3.setBackground(Color.gray);
p3.setPreferredSize(new Dimension(100, 100));
f.add(p3);

JButton b1 = new JButton("JButton 1");  // 5
f.add(b1);
JButton b2 = new JButton("JButton 2");  // 6
f.add(b2);
JButton b3 = new JButton();  // 7
f.add(b3);

JButton b4 = new JButton("JButton 4");  // 8
p2.add(b4);

f.addMouseListener(new MouseAdapter(){public void mouseEntered(MouseEvent e){System.out.println("JFrame in.");}
                                      public void mouseExited(MouseEvent e){System.out.println("JFrame out.");}
                                      public void mouseClicked(MouseEvent e){System.out.println("JFrame clicked.");}});

p1.addMouseListener(new MouseAdapter(){public void mouseEntered(MouseEvent e){System.out.println("JPanel 1 in.");}});
p1.addMouseListener(new MouseAdapter(){public void mouseExited(MouseEvent e){System.out.println("JPanel 1 out.");}});
p1.addMouseListener(new MouseAdapter(){public void mouseClicked(MouseEvent e){System.out.println("JPanel 1 clicked.");}});

p2.addMouseListener(new MouseAdapter(){public void mouseEntered(MouseEvent e){System.out.println("JPanel 2 in.");}});
p2.addMouseListener(new MouseAdapter(){public void mouseExited(MouseEvent e){System.out.println("JPanel 2 out.");}});
p2.addMouseListener(new MouseAdapter(){public void mouseClicked(MouseEvent e){System.out.println("JPanel 2 clicked.");}});

b1.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e){System.out.println("JButton 1 clicked.");}});
b2.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e){System.out.println("JButton 2 clicked.");}});

f.setLocationRelativeTo(null);
f.setVisible(true);

Graphics g0 = f.getGraphics();
Graphics g1 = p1.getGraphics();
Graphics g2 = p1.getGraphics();
Graphics g3 = p1.getGraphics();

p1.setSize(150, 150);
