/**
   https://docs.oracle.com/javase/8/docs/api/java/awt/event/ActionListener.html

   https://docs.oracle.com/javase/8/docs/api/java/awt/event/ActionEvent.html
*/

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class Watch_Action
{
   public static void main(String[] args)
   {
      JFrame jf = new JFrame("Action Example");
      jf.setLayout(new FlowLayout());
      jf.setSize(400, 400);
      jf.setVisible(true);

      JComboBox<String> combobox = new JComboBox<>();
      combobox.addItem("Item 1");
      combobox.addItem("Item 2");
      combobox.addItem("Item 3");
      combobox.addActionListener(new HandleAction());
      jf.add(combobox);
   }
}

class HandleAction implements ActionListener
{
   @Override public void actionPerformed(ActionEvent e){System.out.println(e+"\n");}
}
